/** Copyright (c) 2019 Uber Technologies, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
import * as React from 'react';
import type { ReactElement } from 'react';
export declare const FusionContext: React.Context<any>;
export declare const ServiceContext: React.Context<any>;
type ReturnsType<T> = () => T;
export declare function useService<TService>(token: ReturnsType<TService>): TService;
type ServiceConsumerProps<TService> = {
    token: ReturnsType<TService>;
    children: (a: TService) => ReactElement<any>;
};
export declare function ServiceConsumer<TService>({ token, children, }: ServiceConsumerProps<TService>): JSX.Element;
type Dependencies = {
    [x: string]: ReturnsType<unknown>;
};
type Services = {
    [x: string]: ReturnsType<unknown>;
};
type Props = {
    [x: string]: any;
};
type Mapper = (a: Services) => Props;
export declare function withServices(deps: Dependencies, mapServicesToProps?: Mapper): (Component: React.ComponentType<any>) => (props?: Props) => JSX.Element;
export {};
//# sourceMappingURL=context.d.ts.map